Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 6968)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 7207)
@@ -178,5 +178,5 @@
     {
         USBFilter ()
-            : mAction (USBDeviceFilterAction_InvalidUSBDeviceFilterAction)
+            : mAction (USBDeviceFilterAction_Null)
             {}
 
@@ -913,7 +913,7 @@
         RTPrintf("Time offset:     %lld ms\n", timeOffset);
 
-    TriStateBool_T hwVirtExEnabled;
+    TSBool_T hwVirtExEnabled;
     machine->COMGETTER(HWVirtExEnabled)(&hwVirtExEnabled);
-    if (hwVirtExEnabled == TriStateBool_TSDefault)
+    if (hwVirtExEnabled == TSBool_Default)
     {
         BOOL fHWVirtExEnabled;
@@ -929,7 +929,7 @@
     {
         if (details == VMINFO_MACHINEREADABLE)
-            RTPrintf("hwvirtex=\"%s\"\n", hwVirtExEnabled == TriStateBool_TSTrue ? "on" : "off");
+            RTPrintf("hwvirtex=\"%s\"\n", hwVirtExEnabled == TSBool_True ? "on" : "off");
         else
-            RTPrintf("Hardw. virt.ext: %s\n", hwVirtExEnabled == TriStateBool_TSTrue ? "on" : "off");
+            RTPrintf("Hardw. virt.ext: %s\n", hwVirtExEnabled == TSBool_True ? "on" : "off");
     }
 
@@ -1063,5 +1063,5 @@
     ComPtr<IHardDisk> hardDisk;
     Bstr filePath;
-    rc = machine->GetHardDisk(DiskControllerType_IDE0Controller, 0, hardDisk.asOutParam());
+    rc = machine->GetHardDisk(DiskControllerType_IDE0, 0, hardDisk.asOutParam());
     if (SUCCEEDED(rc) && hardDisk)
     {
@@ -1086,5 +1086,5 @@
             RTPrintf("hda=\"none\"\n");
     }
-    rc = machine->GetHardDisk(DiskControllerType_IDE0Controller, 1, hardDisk.asOutParam());
+    rc = machine->GetHardDisk(DiskControllerType_IDE0, 1, hardDisk.asOutParam());
     if (SUCCEEDED(rc) && hardDisk)
     {
@@ -1109,5 +1109,5 @@
             RTPrintf("hdb=\"none\"\n");
     }
-    rc = machine->GetHardDisk(DiskControllerType_IDE1Controller, 1, hardDisk.asOutParam());
+    rc = machine->GetHardDisk(DiskControllerType_IDE1, 1, hardDisk.asOutParam());
     if (SUCCEEDED(rc) && hardDisk)
     {
@@ -1217,5 +1217,5 @@
                 switch (attachment)
                 {
-                    case NetworkAttachmentType_NoNetworkAttachment:
+                    case NetworkAttachmentType_Null:
                         if (details == VMINFO_MACHINEREADABLE)
                             strAttachment = "null";
@@ -1223,5 +1223,5 @@
                             strAttachment = "none";
                         break;
-                    case NetworkAttachmentType_NATNetworkAttachment:
+                    case NetworkAttachmentType_NAT:
                         if (details == VMINFO_MACHINEREADABLE)
                             strAttachment = "nat";
@@ -1229,5 +1229,5 @@
                             strAttachment = "NAT";
                         break;
-                    case NetworkAttachmentType_HostInterfaceNetworkAttachment:
+                    case NetworkAttachmentType_HostInterface:
                     {
                         Bstr strHostIfDev;
@@ -1242,5 +1242,5 @@
                         break;
                     }
-                    case NetworkAttachmentType_InternalNetworkAttachment:
+                    case NetworkAttachmentType_Internal:
                     {
                         Bstr strNetwork;
@@ -1275,12 +1275,12 @@
                 nic->COMGETTER(AdapterType)(&NICType);
                 switch (NICType) {
-                case NetworkAdapterType_NetworkAdapterAm79C970A:
+                case NetworkAdapterType_Am79C970A:
                     strNICType = "Am79C970A";
                     break;
-                case NetworkAdapterType_NetworkAdapterAm79C973:
+                case NetworkAdapterType_Am79C973:
                     strNICType = "Am79C973";
                     break;
 #ifdef VBOX_WITH_E1000
-                case NetworkAdapterType_NetworkAdapter82540EM:
+                case NetworkAdapterType_I82540EM:
                     strNICType = "82540EM";
                     break;
@@ -1351,5 +1351,5 @@
                 {
                     default:
-                    case PortMode_DisconnectedPort:
+                    case PortMode_Disconnected:
                         if (details == VMINFO_MACHINEREADABLE)
                             RTPrintf("uartmode%d=\"disconnected\"\n", currentUART + 1);
@@ -1357,5 +1357,5 @@
                             RTPrintf(", disconnected\n");
                         break;
-                    case PortMode_HostPipePort:
+                    case PortMode_HostPipe:
                         if (details == VMINFO_MACHINEREADABLE)
                             RTPrintf("uartmode%d=\"%s,%lS\"\n", currentUART + 1,
@@ -1365,5 +1365,5 @@
                                      fServer ? "server" : "client", path.raw());
                         break;
-                    case PortMode_HostDevicePort:
+                    case PortMode_HostDevice:
                         if (details == VMINFO_MACHINEREADABLE)
                             RTPrintf("uartmode%d=\"%lS\"\n", currentUART + 1,
@@ -1391,5 +1391,5 @@
             switch (enmDrvType)
             {
-                case AudioDriverType_NullAudioDriver:
+                case AudioDriverType_Null:
                     if (details == VMINFO_MACHINEREADABLE)
                         pszDrv = "null";
@@ -1397,5 +1397,5 @@
                         pszDrv = "Null";
                     break;
-                case AudioDriverType_WINMMAudioDriver:
+                case AudioDriverType_WINMM:
                     if (details == VMINFO_MACHINEREADABLE)
                         pszDrv = "winmm";
@@ -1403,5 +1403,5 @@
                         pszDrv = "WINMM";
                     break;
-                case AudioDriverType_DSOUNDAudioDriver:
+                case AudioDriverType_DSOUND:
                     if (details == VMINFO_MACHINEREADABLE)
                         pszDrv = "dsound";
@@ -1409,5 +1409,5 @@
                         pszDrv = "DSOUND";
                     break;
-                case AudioDriverType_OSSAudioDriver:
+                case AudioDriverType_OSS:
                     if (details == VMINFO_MACHINEREADABLE)
                         pszDrv = "oss";
@@ -1415,5 +1415,5 @@
                         pszDrv = "OSS";
                     break;
-                case AudioDriverType_ALSAAudioDriver:
+                case AudioDriverType_ALSA:
                     if (details == VMINFO_MACHINEREADABLE)
                         pszDrv = "alsa";
@@ -1421,5 +1421,5 @@
                         pszDrv = "ALSA";
                     break;
-                case AudioDriverType_PulseAudioDriver:
+                case AudioDriverType_Pulse:
                     if (details == VMINFO_MACHINEREADABLE)
                         pszDrv = "pulse";
@@ -1427,5 +1427,5 @@
                         pszDrv = "PulseAudio";
                     break;
-                case AudioDriverType_CoreAudioDriver:
+                case AudioDriverType_Core:
                     if (details == VMINFO_MACHINEREADABLE)
                         pszDrv = "coreaudio";
@@ -1477,5 +1477,5 @@
         switch (enmMode)
         {
-            case ClipboardMode_ClipDisabled:
+            case ClipboardMode_Disabled:
                 if (details == VMINFO_MACHINEREADABLE)
                     psz = "disabled";
@@ -1483,5 +1483,5 @@
                     psz = "disabled";
                 break;
-            case ClipboardMode_ClipHostToGuest:
+            case ClipboardMode_HostToGuest:
                 if (details == VMINFO_MACHINEREADABLE)
                     psz = "hosttoguest";
@@ -1489,5 +1489,5 @@
                     psz = "HostToGuest";
                 break;
-            case ClipboardMode_ClipGuestToHost:
+            case ClipboardMode_GuestToHost:
                 if (details == VMINFO_MACHINEREADABLE)
                     psz = "guesttohost";
@@ -1495,5 +1495,5 @@
                     psz = "GuestToHost";
                 break;
-            case ClipboardMode_ClipBidirectional:
+            case ClipboardMode_Bidirectional:
                 if (details == VMINFO_MACHINEREADABLE)
                     psz = "bidirectional";
@@ -1548,11 +1548,11 @@
             switch (vrdpAuthType)
             {
-                case VRDPAuthType_VRDPAuthNull:
+                case VRDPAuthType_Null:
                     strAuthType = "null";
                     break;
-                case VRDPAuthType_VRDPAuthExternal:
+                case VRDPAuthType_External:
                     strAuthType = "external";
                     break;
-                case VRDPAuthType_VRDPAuthGuest:
+                case VRDPAuthType_Guest:
                     strAuthType = "guest";
                     break;
@@ -2685,5 +2685,5 @@
             RTPrintf("Accessible: %s\n", fAccessible ? "yes" : "no");
             Bstr machineUUIDs;
-            CHECK_ERROR(virtualBox, GetDVDImageUsage(uuid, ResourceUsage_AllUsage, machineUUIDs.asOutParam()));
+            CHECK_ERROR(virtualBox, GetDVDImageUsage(uuid, ResourceUsage_All, machineUUIDs.asOutParam()));
             /** @todo usage */
             RTPrintf("\n");
@@ -2712,5 +2712,5 @@
             RTPrintf("Accessible: %s\n", fAccessible ? "yes" : "no");
             Bstr machineUUIDs;
-            CHECK_ERROR(virtualBox, GetFloppyImageUsage(uuid, ResourceUsage_AllUsage, machineUUIDs.asOutParam()));
+            CHECK_ERROR(virtualBox, GetFloppyImageUsage(uuid, ResourceUsage_All, machineUUIDs.asOutParam()));
             /** @todo usage */
             RTPrintf("\n");
@@ -2786,15 +2786,15 @@
             switch (state)
             {
-                case USBDeviceState_USBDeviceNotSupported:
+                case USBDeviceState_NotSupported:
                     pszState = "Not supported"; break;
-                case USBDeviceState_USBDeviceUnavailable:
+                case USBDeviceState_Unavailable:
                     pszState = "Unavailable"; break;
-                case USBDeviceState_USBDeviceBusy:
+                case USBDeviceState_Busy:
                     pszState = "Busy"; break;
-                case USBDeviceState_USBDeviceAvailable:
+                case USBDeviceState_Available:
                     pszState = "Available"; break;
-                case USBDeviceState_USBDeviceHeld:
+                case USBDeviceState_Held:
                     pszState = "Held"; break;
-                case USBDeviceState_USBDeviceCaptured:
+                case USBDeviceState_Captured:
                     pszState = "Captured"; break;
                 default:
@@ -2851,8 +2851,8 @@
             switch (action)
             {
-                case USBDeviceFilterAction_USBDeviceFilterIgnore:
+                case USBDeviceFilterAction_Ignore:
                     pszAction = "Ignore";
                     break;
-                case USBDeviceFilterAction_USBDeviceFilterHold:
+                case USBDeviceFilterAction_Hold:
                     pszAction = "Hold";
                     break;
@@ -3100,5 +3100,5 @@
                     else if (strcmp(type, "writethrough") == 0)
                     {
-                        CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_WritethroughHardDisk));
+                        CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_Writethrough));
                     }
 
@@ -3182,17 +3182,17 @@
             if (strcmp(type, "normal") == 0)
             {
-                if (hddType != HardDiskType_NormalHardDisk)
-                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_NormalHardDisk));
+                if (hddType != HardDiskType_Normal)
+                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_Normal));
             }
             else if (strcmp(type, "writethrough") == 0)
             {
-                if (hddType != HardDiskType_WritethroughHardDisk)
-                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_WritethroughHardDisk));
+                if (hddType != HardDiskType_Writethrough)
+                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_Writethrough));
 
             }
             else if (strcmp(type, "immutable") == 0)
             {
-                if (hddType != HardDiskType_ImmutableHardDisk)
-                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_ImmutableHardDisk));
+                if (hddType != HardDiskType_Immutable)
+                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_Immutable));
             }
             else
@@ -3895,21 +3895,21 @@
             if (strcmp(argv[i], "none") == 0)
             {
-                bootDevice[n - 1] = DeviceType_NoDevice;
+                bootDevice[n - 1] = DeviceType_Null;
             }
             else if (strcmp(argv[i], "floppy") == 0)
             {
-                bootDevice[n - 1] = DeviceType_FloppyDevice;
+                bootDevice[n - 1] = DeviceType_Floppy;
             }
             else if (strcmp(argv[i], "dvd") == 0)
             {
-                bootDevice[n - 1] = DeviceType_DVDDevice;
+                bootDevice[n - 1] = DeviceType_DVD;
             }
             else if (strcmp(argv[i], "disk") == 0)
             {
-                bootDevice[n - 1] = DeviceType_HardDiskDevice;
+                bootDevice[n - 1] = DeviceType_HardDisk;
             }
             else if (strcmp(argv[i], "net") == 0)
             {
-                bootDevice[n - 1] = DeviceType_NetworkDevice;
+                bootDevice[n - 1] = DeviceType_Network;
             }
             else
@@ -4403,13 +4403,13 @@
             if (strcmp(hwvirtex, "on") == 0)
             {
-                CHECK_ERROR(machine, COMSETTER(HWVirtExEnabled)(TriStateBool_TSTrue));
+                CHECK_ERROR(machine, COMSETTER(HWVirtExEnabled)(TSBool_True));
             }
             else if (strcmp(hwvirtex, "off") == 0)
             {
-                CHECK_ERROR(machine, COMSETTER(HWVirtExEnabled)(TriStateBool_TSFalse));
+                CHECK_ERROR(machine, COMSETTER(HWVirtExEnabled)(TSBool_False));
             }
             else if (strcmp(hwvirtex, "default") == 0)
             {
-                CHECK_ERROR(machine, COMSETTER(HWVirtExEnabled)(TriStateBool_TSDefault));
+                CHECK_ERROR(machine, COMSETTER(HWVirtExEnabled)(TSBool_Default));
             }
             else
@@ -4513,5 +4513,5 @@
             if (strcmp(hdds[0], "none") == 0)
             {
-                machine->DetachHardDisk(DiskControllerType_IDE0Controller, 0);
+                machine->DetachHardDisk(DiskControllerType_IDE0, 0);
             }
             else
@@ -4546,5 +4546,5 @@
                 {
                     hardDisk->COMGETTER(Id)(uuid.asOutParam());
-                    CHECK_ERROR(machine, AttachHardDisk(uuid, DiskControllerType_IDE0Controller, 0));
+                    CHECK_ERROR(machine, AttachHardDisk(uuid, DiskControllerType_IDE0, 0));
                 }
                 else
@@ -4558,5 +4558,5 @@
             if (strcmp(hdds[1], "none") == 0)
             {
-                machine->DetachHardDisk(DiskControllerType_IDE0Controller, 1);
+                machine->DetachHardDisk(DiskControllerType_IDE0, 1);
             }
             else
@@ -4591,5 +4591,5 @@
                 {
                     hardDisk->COMGETTER(Id)(uuid.asOutParam());
-                    CHECK_ERROR(machine, AttachHardDisk(uuid, DiskControllerType_IDE0Controller, 1));
+                    CHECK_ERROR(machine, AttachHardDisk(uuid, DiskControllerType_IDE0, 1));
                 }
                 else
@@ -4603,5 +4603,5 @@
             if (strcmp(hdds[2], "none") == 0)
             {
-                machine->DetachHardDisk(DiskControllerType_IDE1Controller, 1);
+                machine->DetachHardDisk(DiskControllerType_IDE1, 1);
             }
             else
@@ -4636,5 +4636,5 @@
                 {
                     hardDisk->COMGETTER(Id)(uuid.asOutParam());
-                    CHECK_ERROR(machine, AttachHardDisk(uuid, DiskControllerType_IDE1Controller, 1));
+                    CHECK_ERROR(machine, AttachHardDisk(uuid, DiskControllerType_IDE1, 1));
                 }
                 else
@@ -4809,5 +4809,5 @@
                 else if (strcmp(audio, "null") == 0)
                 {
-                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_NullAudioDriver));
+                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_Null));
                     CHECK_ERROR(audioAdapter, COMSETTER(Enabled)(true));
                 }
@@ -4816,5 +4816,5 @@
                 else if (strcmp(audio, "winmm") == 0)
                 {
-                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_WINMMAudioDriver));
+                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_WINMM));
                     CHECK_ERROR(audioAdapter, COMSETTER(Enabled)(true));
                 }
@@ -4822,5 +4822,5 @@
                 else if (strcmp(audio, "dsound") == 0)
                 {
-                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_DSOUNDAudioDriver));
+                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_DSOUND));
                     CHECK_ERROR(audioAdapter, COMSETTER(Enabled)(true));
                 }
@@ -4829,5 +4829,5 @@
                 else if (strcmp(audio, "oss") == 0)
                 {
-                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_OSSAudioDriver));
+                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_OSS));
                     CHECK_ERROR(audioAdapter, COMSETTER(Enabled)(true));
                 }
@@ -4835,5 +4835,5 @@
                 else if (strcmp(audio, "alsa") == 0)
                 {
-                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_ALSAAudioDriver));
+                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_ALSA));
                     CHECK_ERROR(audioAdapter, COMSETTER(Enabled)(true));
                 }
@@ -4842,5 +4842,5 @@
                 else if (strcmp(audio, "pulse") == 0)
                 {
-                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_PulseAudioDriver));
+                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_Pulse));
                     CHECK_ERROR(audioAdapter, COMSETTER(Enabled)(true));
                 }
@@ -4850,5 +4850,5 @@
                 else if (strcmp(audio, "coreaudio") == 0)
                 {
-                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_CoreAudioDriver));
+                    CHECK_ERROR(audioAdapter, COMSETTER(AudioDriver)(AudioDriverType_Core));
                     CHECK_ERROR(audioAdapter, COMSETTER(Enabled)(true));
                 }
@@ -4885,17 +4885,17 @@
             if (strcmp(clipboard, "disabled") == 0)
             {
-                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_ClipDisabled));
+                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_Disabled));
             }
             else if (strcmp(clipboard, "hosttoguest") == 0)
             {
-                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_ClipHostToGuest));
+                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_HostToGuest));
             }
             else if (strcmp(clipboard, "guesttohost") == 0)
             {
-                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_ClipGuestToHost));
+                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_GuestToHost));
             }
             else if (strcmp(clipboard, "bidirectional") == 0)
             {
-                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_ClipBidirectional));
+                CHECK_ERROR(machine, COMSETTER(ClipboardMode)(ClipboardMode_Bidirectional));
             }
             else
@@ -4954,14 +4954,14 @@
                 if (strcmp(nictype[n], "Am79C970A") == 0)
                 {
-                    CHECK_ERROR_RET(nic, COMSETTER(AdapterType)(NetworkAdapterType_NetworkAdapterAm79C970A), 1);
+                    CHECK_ERROR_RET(nic, COMSETTER(AdapterType)(NetworkAdapterType_Am79C970A), 1);
                 }
                 else if (strcmp(nictype[n], "Am79C973") == 0)
                 {
-                    CHECK_ERROR_RET(nic, COMSETTER(AdapterType)(NetworkAdapterType_NetworkAdapterAm79C973), 1);
+                    CHECK_ERROR_RET(nic, COMSETTER(AdapterType)(NetworkAdapterType_Am79C973), 1);
                 }
 #ifdef VBOX_WITH_E1000
                 else if (strcmp(nictype[n], "82540EM") == 0)
                 {
-                    CHECK_ERROR_RET(nic, COMSETTER(AdapterType)(NetworkAdapterType_NetworkAdapter82540EM), 1);
+                    CHECK_ERROR_RET(nic, COMSETTER(AdapterType)(NetworkAdapterType_I82540EM), 1);
                 }
 #endif
@@ -5135,5 +5135,5 @@
                 if (strcmp(uarts_mode[n], "disconnected") == 0)
                 {
-                    CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_DisconnectedPort), 1);
+                    CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_Disconnected), 1);
                 }
                 else
@@ -5141,15 +5141,15 @@
                     if (strcmp(uarts_mode[n], "server") == 0)
                     {
-                        CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_HostPipePort), 1);
+                        CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_HostPipe), 1);
                         CHECK_ERROR_RET(uart, COMSETTER(Server) (TRUE), 1);
                     }
                     else if (strcmp(uarts_mode[n], "client") == 0)
                     {
-                        CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_HostPipePort), 1);
+                        CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_HostPipe), 1);
                         CHECK_ERROR_RET(uart, COMSETTER(Server) (FALSE), 1);
                     }
                     else
                     {
-                        CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_HostDevicePort), 1);
+                        CHECK_ERROR_RET(uart, COMSETTER(HostMode) (PortMode_HostDevice), 1);
                     }
                     CHECK_ERROR_RET(uart, COMSETTER(Path) (Bstr(uarts_path[n])), 1);
@@ -5197,13 +5197,13 @@
                     if (strcmp(vrdpauthtype, "null") == 0)
                     {
-                        CHECK_ERROR(vrdpServer, COMSETTER(AuthType)(VRDPAuthType_VRDPAuthNull));
+                        CHECK_ERROR(vrdpServer, COMSETTER(AuthType)(VRDPAuthType_Null));
                     }
                     else if (strcmp(vrdpauthtype, "external") == 0)
                     {
-                        CHECK_ERROR(vrdpServer, COMSETTER(AuthType)(VRDPAuthType_VRDPAuthExternal));
+                        CHECK_ERROR(vrdpServer, COMSETTER(AuthType)(VRDPAuthType_External));
                     }
                     else if (strcmp(vrdpauthtype, "guest") == 0)
                     {
-                        CHECK_ERROR(vrdpServer, COMSETTER(AuthType)(VRDPAuthType_VRDPAuthGuest));
+                        CHECK_ERROR(vrdpServer, COMSETTER(AuthType)(VRDPAuthType_Guest));
                     }
                     else
@@ -6201,11 +6201,11 @@
         switch (type)
         {
-            case HardDiskType_NormalHardDisk:
+            case HardDiskType_Normal:
                 typeStr = "standard";
                 break;
-            case HardDiskType_ImmutableHardDisk:
+            case HardDiskType_Immutable:
                 typeStr = "immutable";
                 break;
-            case HardDiskType_WritethroughHardDisk:
+            case HardDiskType_Writethrough:
                 typeStr = "writethrough";
                 break;
@@ -6300,9 +6300,9 @@
             {
                 if (strcmp(type, "normal") == 0)
-                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_NormalHardDisk));
+                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_Normal));
                 else if (strcmp(type, "immutable") == 0)
-                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_ImmutableHardDisk));
+                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_Immutable));
                 else if (strcmp(type, "writethrough") == 0)
-                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_WritethroughHardDisk));
+                    CHECK_ERROR(hardDisk, COMSETTER(Type)(HardDiskType_Writethrough));
             }
             if (SUCCEEDED(rc))
@@ -6878,7 +6878,7 @@
                     i++;
                     if (strcmp (argv [i], "ignore") == 0)
-                        cmd.mFilter.mAction = USBDeviceFilterAction_USBDeviceFilterIgnore;
+                        cmd.mFilter.mAction = USBDeviceFilterAction_Ignore;
                     else if (strcmp (argv [i], "hold") == 0)
-                        cmd.mFilter.mAction = USBDeviceFilterAction_USBDeviceFilterHold;
+                        cmd.mFilter.mAction = USBDeviceFilterAction_Hold;
                     else
                     {
@@ -6899,5 +6899,5 @@
                     ||
                        (   cmd.mGlobal
-                        && cmd.mFilter.mAction == USBDeviceFilterAction_InvalidUSBDeviceFilterAction
+                        && cmd.mFilter.mAction == USBDeviceFilterAction_Null
                        )
                     || (   !cmd.mGlobal
@@ -6999,5 +6999,5 @@
                     CHECK_ERROR_BREAK (flt, COMSETTER(MaskedInterfaces) (f.mMaskedInterfaces));
 
-                if (f.mAction != USBDeviceFilterAction_InvalidUSBDeviceFilterAction)
+                if (f.mAction != USBDeviceFilterAction_Null)
                     CHECK_ERROR_BREAK (flt, COMSETTER(Action) (f.mAction));
 
@@ -7056,5 +7056,5 @@
                     CHECK_ERROR_BREAK (flt, COMSETTER(MaskedInterfaces) (f.mMaskedInterfaces));
 
-                if (f.mAction != USBDeviceFilterAction_InvalidUSBDeviceFilterAction)
+                if (f.mAction != USBDeviceFilterAction_Null)
                     CHECK_ERROR_BREAK (flt, COMSETTER(Action) (f.mAction));
             }