Index: trunk/src/VBox/Additions/WINNT/VBoxGuest/Helper.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxGuest/Helper.cpp	(revision 7232)
+++ trunk/src/VBox/Additions/WINNT/VBoxGuest/Helper.cpp	(revision 7233)
@@ -201,21 +201,21 @@
         {
             case WINNT4:
-                req->guestInfo.osType = OSTypeWinNT4;
+                req->guestInfo.osType = VBOXOSTYPE_WinNT4;
                 break;
             case WIN2K:
-                req->guestInfo.osType = OSTypeWin2k;
+                req->guestInfo.osType = VBOXOSTYPE_Win2k;
                 break;
             case WINXP:
-                req->guestInfo.osType = OSTypeWinXP;
+                req->guestInfo.osType = VBOXOSTYPE_WinXP;
                 break;
             case WIN2K3:
-                req->guestInfo.osType = OSTypeWin2k3;
+                req->guestInfo.osType = VBOXOSTYPE_Win2k3;
                 break;
             case WINVISTA:
-                req->guestInfo.osType = OSTypeWinVista;
+                req->guestInfo.osType = VBOXOSTYPE_WinVista;
                 break;
             default:
                 /* we don't know, therefore NT family */
-                req->guestInfo.osType = OSTypeWinNT;
+                req->guestInfo.osType = VBOXOSTYPE_WinNT;
                 break;
         }
Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-os2.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-os2.cpp	(revision 7232)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-os2.cpp	(revision 7233)
@@ -335,5 +335,5 @@
 static VBOXOSTYPE vboxGuestOS2DetectVersion(void)
 {
-    VBOXOSTYPE enmOSType = OSTypeOS2;
+    VBOXOSTYPE enmOSType = VBOXOSTYPE_OS2;
 
 #if 0 /** @todo dig up the version stuff from GIS later and verify that the numbers are actually decimal. */
@@ -342,9 +342,9 @@
     {
         if (uMinor >= 30 && uMinor < 40)
-            enmOSType = OSTypeOS2Warp3;
+            enmOSType = VBOXOSTYPE_OS2Warp3;
         else if (uMinor >= 40 && uMinor < 45)
-            enmOSType = OSTypeOS2Warp4;
+            enmOSType = VBOXOSTYPE_OS2Warp4;
         else if (uMinor >= 45 && uMinor < 50)
-            enmOSType = OSTypeOS2Warp45;
+            enmOSType = VBOXOSTYPE_OS2Warp45;
     }
 #endif
Index: trunk/src/VBox/Additions/linux/module/vboxmod.c
===================================================================
--- trunk/src/VBox/Additions/linux/module/vboxmod.c	(revision 7232)
+++ trunk/src/VBox/Additions/linux/module/vboxmod.c	(revision 7233)
@@ -874,7 +874,7 @@
     infoReq->guestInfo.additionsVersion = VMMDEV_VERSION;
 #if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 0)
-    infoReq->guestInfo.osType = OSTypeLinux26;
+    infoReq->guestInfo.osType = VBOXOSTYPE_Linux26;
 #else
-    infoReq->guestInfo.osType = OSTypeLinux24;
+    infoReq->guestInfo.osType = VBOXOSTYPE_Linux24;
 #endif
     rcVBox = VbglGRPerform(&infoReq->header);
Index: trunk/src/VBox/Frontends/VBoxBFE/SDLConsole.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxBFE/SDLConsole.cpp	(revision 7232)
+++ trunk/src/VBox/Frontends/VBoxBFE/SDLConsole.cpp	(revision 7233)
@@ -23,5 +23,4 @@
 #ifdef RT_OS_DARWIN
 # include <Carbon/Carbon.h>
-# define OSType VBoxOSType
 # undef PAGE_SIZE
 # undef PAGE_SHIFT
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h	(revision 7232)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h	(revision 7233)
@@ -40,6 +40,4 @@
 # include <Carbon/Carbon.h>
 # include "DarwinCursor.h"
-/** @todo remove this hack when somebody get around fixing the conflicting typedef/enum OSType. */
-# define OSType VBoxOSType
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 7232)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 7233)
@@ -3596,5 +3596,5 @@
      *       succeeded. */
     ICInstance icInstance;
-    OSType psiSignature = 'psi ';
+    VBOXOSTYPE psiSignature = 'psi ';
     OSStatus error = ::ICStart (&icInstance, psiSignature);
     if (error == noErr)
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleView.h	(revision 7232)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleView.h	(revision 7233)
@@ -45,6 +45,4 @@
 # include <Carbon/Carbon.h>
 # include "DarwinCursor.h"
-/** @todo remove this hack when somebody get around fixing the conflicting typedef/enum OSType. */
-# define OSType VBoxOSType
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 7232)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 7233)
@@ -3602,5 +3602,5 @@
      *       succeeded. */
     ICInstance icInstance;
-    OSType psiSignature = 'psi ';
+    VBOXOSTYPE psiSignature = 'psi ';
     OSStatus error = ::ICStart (&icInstance, psiSignature);
     if (error == noErr)
Index: trunk/src/VBox/Main/GuestOSTypeImpl.cpp
===================================================================
--- trunk/src/VBox/Main/GuestOSTypeImpl.cpp	(revision 7232)
+++ trunk/src/VBox/Main/GuestOSTypeImpl.cpp	(revision 7233)
@@ -24,5 +24,5 @@
 
 GuestOSType::GuestOSType()
-    : mOSType (OSTypeUnknown)
+    : mOSType (VBOXOSTYPE_Unknown)
     , mRAMSize (0), mVRAMSize (0)
     , mHDDSize (0), mMonitorCount (0)
@@ -58,5 +58,5 @@
  * @param aHDDSize     recommended HDD size in megabytes
  */
-HRESULT GuestOSType::init (const char *aId, const char *aDescription, OSType aOSType,
+HRESULT GuestOSType::init (const char *aId, const char *aDescription, VBOXOSTYPE aOSType,
                            uint32_t aRAMSize, uint32_t aVRAMSize, uint32_t aHDDSize)
 {
Index: trunk/src/VBox/Main/VirtualBoxImpl.cpp
===================================================================
--- trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 7232)
+++ trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 7233)
@@ -4316,5 +4316,5 @@
         const char    *id;          // utf-8
         const char    *description; // utf-8
-        const OSType   osType;
+        const VBOXOSTYPE osType;
         const uint32_t recommendedRAM;
         const uint32_t recommendedVRAM;
@@ -4326,27 +4326,27 @@
          * NOTE2: please use powers of 2 when specifying the size of harddisks since
          *        '2GB' looks better than '1.95GB' (= 2000MB) */
-        { "unknown",    tr ("Other/Unknown"),  OSTypeUnknown,     64,   4,  2 * _1K },
-        { "dos",        "DOS",                 OSTypeDOS,         32,   4,      512 },
-        { "win31",      "Windows 3.1",         OSTypeWin31,       32,   4,  1 * _1K },
-        { "win95",      "Windows 95",          OSTypeWin95,       64,   4,  2 * _1K },
-        { "win98",      "Windows 98",          OSTypeWin98,       64,   4,  2 * _1K },
-        { "winme",      "Windows Me",          OSTypeWinMe,       64,   4,  4 * _1K },
-        { "winnt4",     "Windows NT 4",        OSTypeWinNT4,     128,   4,  2 * _1K },
-        { "win2k",      "Windows 2000",        OSTypeWin2k,      168,   4,  4 * _1K },
-        { "winxp",      "Windows XP",          OSTypeWinXP,      192,   4, 10 * _1K },
-        { "win2k3",     "Windows Server 2003", OSTypeWin2k3,     256,   4, 20 * _1K },
-        { "winvista",   "Windows Vista",       OSTypeWinVista,   512,   4, 20 * _1K },
-        { "os2warp3",   "OS/2 Warp 3",         OSTypeOS2Warp3,    48,   4,  1 * _1K },
-        { "os2warp4",   "OS/2 Warp 4",         OSTypeOS2Warp4,    64,   4,  2 * _1K },
-        { "os2warp45",  "OS/2 Warp 4.5",       OSTypeOS2Warp45,   96,   4,  2 * _1K },
-        { "linux22",    "Linux 2.2",           OSTypeLinux22,     64,   4,  2 * _1K },
-        { "linux24",    "Linux 2.4",           OSTypeLinux24,    128,   4,  4 * _1K },
-        { "linux26",    "Linux 2.6",           OSTypeLinux26,    256,   4,  8 * _1K },
-        { "freebsd",    "FreeBSD",             OSTypeFreeBSD,     64,   4,  2 * _1K },
-        { "openbsd",    "OpenBSD",             OSTypeOpenBSD,     64,   4,  2 * _1K },
-        { "netbsd",     "NetBSD",              OSTypeNetBSD,      64,   4,  2 * _1K },
-        { "netware",    "Netware",             OSTypeNetware,    128,   4,  4 * _1K },
-        { "solaris",    "Solaris",             OSTypeSolaris,    128,   4,  8 * _1K },
-        { "l4",         "L4",                  OSTypeL4,          64,   4,  2 * _1K }
+        { "unknown",    tr ("Other/Unknown"),  VBOXOSTYPE_Unknown,     64,   4,  2 * _1K },
+        { "dos",        "DOS",                 VBOXOSTYPE_DOS,         32,   4,      512 },
+        { "win31",      "Windows 3.1",         VBOXOSTYPE_Win31,       32,   4,  1 * _1K },
+        { "win95",      "Windows 95",          VBOXOSTYPE_Win95,       64,   4,  2 * _1K },
+        { "win98",      "Windows 98",          VBOXOSTYPE_Win98,       64,   4,  2 * _1K },
+        { "winme",      "Windows Me",          VBOXOSTYPE_WinMe,       64,   4,  4 * _1K },
+        { "winnt4",     "Windows NT 4",        VBOXOSTYPE_WinNT4,     128,   4,  2 * _1K },
+        { "win2k",      "Windows 2000",        VBOXOSTYPE_Win2k,      168,   4,  4 * _1K },
+        { "winxp",      "Windows XP",          VBOXOSTYPE_WinXP,      192,   4, 10 * _1K },
+        { "win2k3",     "Windows Server 2003", VBOXOSTYPE_Win2k3,     256,   4, 20 * _1K },
+        { "winvista",   "Windows Vista",       VBOXOSTYPE_WinVista,   512,   4, 20 * _1K },
+        { "os2warp3",   "OS/2 Warp 3",         VBOXOSTYPE_OS2Warp3,    48,   4,  1 * _1K },
+        { "os2warp4",   "OS/2 Warp 4",         VBOXOSTYPE_OS2Warp4,    64,   4,  2 * _1K },
+        { "os2warp45",  "OS/2 Warp 4.5",       VBOXOSTYPE_OS2Warp45,   96,   4,  2 * _1K },
+        { "linux22",    "Linux 2.2",           VBOXOSTYPE_Linux22,     64,   4,  2 * _1K },
+        { "linux24",    "Linux 2.4",           VBOXOSTYPE_Linux24,    128,   4,  4 * _1K },
+        { "linux26",    "Linux 2.6",           VBOXOSTYPE_Linux26,    256,   4,  8 * _1K },
+        { "freebsd",    "FreeBSD",             VBOXOSTYPE_FreeBSD,     64,   4,  2 * _1K },
+        { "openbsd",    "OpenBSD",             VBOXOSTYPE_OpenBSD,     64,   4,  2 * _1K },
+        { "netbsd",     "NetBSD",              VBOXOSTYPE_NetBSD,      64,   4,  2 * _1K },
+        { "netware",    "Netware",             VBOXOSTYPE_Netware,    128,   4,  4 * _1K },
+        { "solaris",    "Solaris",             VBOXOSTYPE_Solaris,    128,   4,  8 * _1K },
+        { "l4",         "L4",                  VBOXOSTYPE_L4,          64,   4,  2 * _1K }
     };
 
Index: trunk/src/VBox/Main/include/GuestOSTypeImpl.h
===================================================================
--- trunk/src/VBox/Main/include/GuestOSTypeImpl.h	(revision 7232)
+++ trunk/src/VBox/Main/include/GuestOSTypeImpl.h	(revision 7233)
@@ -51,5 +51,5 @@
 
     // public initializer/uninitializer for internal purposes only
-    HRESULT init (const char *aId, const char *aDescription, OSType aOSType,
+    HRESULT init (const char *aId, const char *aDescription, VBOXOSTYPE aOSType,
                   uint32_t aRAMSize, uint32_t aVRAMSize, uint32_t aHDDSize);
     void uninit();
@@ -72,5 +72,5 @@
     const Bstr mID;
     const Bstr mDescription;
-    const OSType mOSType;
+    const VBOXOSTYPE mOSType;
     const uint32_t mRAMSize;
     const uint32_t mVRAMSize;