Index: /trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk	(revision 7281)
+++ /trunk/src/VBox/Frontends/VirtualBox4/Makefile.kmk	(revision 7282)
@@ -439,7 +439,7 @@
 	src/darwin/DarwinKeyboard.cpp \
 	src/darwin/DarwinCursor.cpp \
-	src/darwin/VBoxAquaStyle.cpp \
 	src/darwin/VBoxUtils-darwin.cpp \
 	src/VBoxFBQuartz2D.cpp
+#	src/darwin/VBoxAquaStyle.cpp \
 
 ifdef VBOX_WITH_ICHAT_THEATER
@@ -522,7 +522,7 @@
 endif
 VirtualBox_LDFLAGS.os2    = -Zlinker /PM:PM -Zno-fork
-VirtualBox_LDFLAGS.darwin = -framework IOKit
+VirtualBox_LDFLAGS.darwin = -framework IOKit -framework AppKit -framework ApplicationServices -framework Foundation -lz
 ifdef VBOX_WITH_ICHAT_THEATER
- VirtualBox_LDFLAGS.darwin += -framework Foundation -framework AppKit -framework InstantMessage -framework QuartzCore
+ VirtualBox_LDFLAGS.darwin += -framework InstantMessage -framework QuartzCore
 endif
 VirtualBox_LIBS.win       = \
Index: /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxToolBar.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxToolBar.h	(revision 7281)
+++ /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxToolBar.h	(revision 7282)
@@ -26,5 +26,5 @@
 #include <QContextMenuEvent>
 #ifdef Q_WS_MAC
-# include "VBoxAquaStyle.h"
+//# include "VBoxAquaStyle.h"
 #endif
 
@@ -78,18 +78,18 @@
     {
         /* self */
-        QStyle *qs = &VBoxAquaStyle::instance();
-        setStyle(qs);
-
-        /* the buttons */
-        QObjectList *list = queryList ("QToolButton");
-        QObjectListIt it (*list);
-        QObject *obj;
-        while ((obj = it.current()) != 0)
-        {
-            QToolButton *btn = ::qt_cast <QToolButton *> (obj);
-            btn->setStyle (&VBoxAquaStyle::instance());
-            ++ it;
-        }
-        delete list;
+//        QStyle *qs = &VBoxAquaStyle::instance();
+//        setStyle(qs);
+//
+//        /* the buttons */
+//        QObjectList *list = queryList ("QToolButton");
+//        QObjectListIt it (*list);
+//        QObject *obj;
+//        while ((obj = it.current()) != 0)
+//        {
+//            QToolButton *btn = ::qt_cast <QToolButton *> (obj);
+//            btn->setStyle (&VBoxAquaStyle::instance());
+//            ++ it;
+//        }
+//        delete list;
 
         /** @todo the separator */
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp	(revision 7281)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp	(revision 7282)
@@ -2527,8 +2527,9 @@
         }
 #elif defined (Q_WS_MAC)
-        if (aUniKey && aUniKey [0] && !aUniKey [1])
-            processed = processHotKey (QKeySequence (Qt::UNICODE_ACCEL +
-                                                     QChar (aUniKey [0]).upper().unicode()),
-                                       mMainWnd->menuBar());
+#warning port me
+//        if (aUniKey && aUniKey [0] && !aUniKey [1])
+//            processed = processHotKey (QKeySequence (Qt::UNICODE_ACCEL +
+//                                                     QChar (aUniKey [0]).upper().unicode()),
+//                                       mMainWnd->menuBar());
 
         /* Don't consider the hot key as pressed since the guest never saw
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleWnd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleWnd.cpp	(revision 7281)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleWnd.cpp	(revision 7282)
@@ -823,13 +823,14 @@
     QImage osImg100x75 = vboxGlobal().vmGuestOSTypeIcon (osTypeId).convertToImage().smoothScale (100, 75);
     QImage osImg = QImage (":/dock_1.png");
-    bitBlt (&osImg, 14, 22,
-            &osImg100x75, 0, 0,
-            100, 75, /* conversion_flags */ 0);
-    QImage VBoxOverlay = QImage (":/VirtualBox_48px.png");
-    bitBlt (&osImg, osImg.width() - VBoxOverlay.width(), osImg.height() - VBoxOverlay.height(),
-            &VBoxOverlay, 0, 0,
-            VBoxOverlay.width(), VBoxOverlay.height(), /* conversion_flags */ 0);
-    if (dockImgOS)
-        CGImageRelease (dockImgOS);
+#warning port me
+//    bitBlt (&osImg, 14, 22,
+//            &osImg100x75, 0, 0,
+//            100, 75, /* conversion_flags */ 0);
+//    QImage VBoxOverlay = QImage (":/VirtualBox_48px.png");
+//    bitBlt (&osImg, osImg.width() - VBoxOverlay.width(), osImg.height() - VBoxOverlay.height(),
+//            &VBoxOverlay, 0, 0,
+//            VBoxOverlay.width(), VBoxOverlay.height(), /* conversion_flags */ 0);
+//    if (dockImgOS)
+//        CGImageRelease (dockImgOS);
     dockImgOS = ::DarwinQImageToCGImage (&osImg);
     SetApplicationDockTileImage (dockImgOS);
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxProblemReporter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxProblemReporter.cpp	(revision 7281)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxProblemReporter.cpp	(revision 7282)
@@ -2025,5 +2025,5 @@
     Q3Process openApp (QString("/usr/bin/open"));
     openApp.addArgument (qApp->applicationDirPath() + "/UserManual.pdf");
-    openApp.launch ("");
+    openApp.launch (QString(""));
 #endif
 #endif /* VBOX_OSE */
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/darwin/VBoxUtils-darwin.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/darwin/VBoxUtils-darwin.cpp	(revision 7281)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/darwin/VBoxUtils-darwin.cpp	(revision 7282)
@@ -76,5 +76,5 @@
 CGImageRef DarwinQImageFromMimeSourceToCGImage (const char *aSource)
 {
-    QImage qim = QImage::fromMimeSource (QString(":/") + aSource);
+    QImage qim (QString(":/") + aSource);
     Assert (!qim.isNull());
     return DarwinQImageToCGImage (&qim);
@@ -102,5 +102,5 @@
 CGImageRef DarwinQPixmapFromMimeSourceToCGImage (const char *aSource)
 {
-    QPixmap qpm = QPixmap::fromMimeSource (QString(":/" + aSource);
+    QPixmap qpm (QString(":/") + aSource);
     Assert (!qpm.isNull());
     return DarwinQPixmapToCGImage (&qpm);
@@ -126,5 +126,5 @@
 
     /* load the badge */
-    QPixmap badge = QPixmap::fromMimeSource (aSource);
+    QPixmap badge (aSource);
     Assert (!badge.isNull());
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxNewVMWzd.ui.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxNewVMWzd.ui.h	(revision 7281)
+++ /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxNewVMWzd.ui.h	(revision 7282)
@@ -185,5 +185,5 @@
     /* setup minimum width for the sizeHint to be calculated correctly */
 #warning port me: check this
-    int wid = spacerItem->minimumSize().width();
+    int wid = 1;
 //    int wid = widthSpacer->minimumSize().width();
     txWelcome->setMinimumWidth (wid);