Index: trunk/src/libs/libxslt-1.1.22/Makefile.kmk
===================================================================
--- trunk/src/libs/libxslt-1.1.22/Makefile.kmk	(revision 7299)
+++ trunk/src/libs/libxslt-1.1.22/Makefile.kmk	(revision 7299)
@@ -0,0 +1,54 @@
+# $Id$
+## @file
+# Makefile for the libxslt library.
+#
+
+#
+#  Copyright (C) 2008 innotek GmbH
+#
+#  This file is part of VirtualBox Open Source Edition (OSE), as
+#  available from http://www.virtualbox.org. This file is free software;
+#  you can redistribute it and/or modify it under the terms of the GNU
+#  General Public License as published by the Free Software Foundation,
+#  in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
+#  distribution. VirtualBox OSE is distributed in the hope that it will
+#  be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+
+DEPTH = ../../..
+include $(PATH_KBUILD)/header.kmk
+
+LIBRARIES = VBox-libxslt
+
+VBox-libxslt_TEMPLATE       = VBOXR3
+VBox-libxslt_SDKS           = VBOX_LIBXML2 VBOX_ZLIB
+VBox-libxslt_DEFS           = LIBXML_STATIC
+VBox-libxslt_DEFS.win       = WIN32 _WINDOWS _MBCS _REENTRANT
+VBox-libxslt_CFLAGS.win.amd64 = -wd4267
+VBox-libxslt_INCS           = .
+VBox-libxslt_SOURCES        = \
+	libxslt/attributes.c \
+	libxslt/documents.c \
+	libxslt/extensions.c \
+	libxslt/extra.c \
+	libxslt/functions.c \
+	libxslt/imports.c \
+	libxslt/keys.c \
+	libxslt/namespaces.c \
+	libxslt/numbers.c \
+	libxslt/pattern.c \
+	libxslt/preproc.c \
+	libxslt/security.c \
+	libxslt/templates.c \
+	libxslt/transform.c \
+	libxslt/variables.c \
+	libxslt/xslt.c \
+	libxslt/xsltutils.c \
+	libxslt/attrvt.c
+
+# For linking:
+# VBox-libxslt_LDFLAGS.win    = /VERSION:$(LIBXSLT_MAJOR_VERSION).$(LIBXSLT_MINOR_VERSION)
+# VBox-libxslt_SDKS.win      += WINPSDK
+
+include $(PATH_KBUILD)/footer.kmk
+
Index: trunk/src/libs/libxslt-1.1.22/README.vbox
===================================================================
--- trunk/src/libs/libxslt-1.1.22/README.vbox	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/README.vbox	(revision 7299)
@@ -1,1 +1,2 @@
-This is a normal libxslt source tarball with the tests/ subdirectory removed.
+This is a normal libxslt source tarball with the tests/ subdirectory removed
+and created vboxconfig.h to replace config.h on linux platforms.
Index: trunk/src/libs/libxslt-1.1.22/libexslt/common.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/common.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/common.c	(revision 7299)
@@ -4,4 +4,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/crypto.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/crypto.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/crypto.c	(revision 7299)
@@ -4,4 +4,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/date.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/date.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/date.c	(revision 7299)
@@ -25,4 +25,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/dynamic.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/dynamic.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/dynamic.c	(revision 7299)
@@ -26,4 +26,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/exslt.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/exslt.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/exslt.c	(revision 7299)
@@ -4,5 +4,9 @@
 #include <libxml/xmlversion.h>
 
+#if defined(VBOX)
+#include "vboxconfig.h"
+#else
 #include "config.h"
+#endif
 
 #include <libxslt/xsltconfig.h>
Index: trunk/src/libs/libxslt-1.1.22/libexslt/functions.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/functions.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/functions.c	(revision 7299)
@@ -4,4 +4,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/libexslt.h
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/libexslt.h	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/libexslt.h	(revision 7299)
@@ -12,4 +12,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && !defined (__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/math.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/math.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/math.c	(revision 7299)
@@ -4,4 +4,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/saxon.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/saxon.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/saxon.c	(revision 7299)
@@ -4,4 +4,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/sets.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/sets.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/sets.c	(revision 7299)
@@ -4,4 +4,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libexslt/strings.c
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libexslt/strings.c	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libexslt/strings.c	(revision 7299)
@@ -4,4 +4,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && (!__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libxslt/libxslt.h
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libxslt/libxslt.h	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libxslt/libxslt.h	(revision 7299)
@@ -13,4 +13,6 @@
 #if defined(WIN32) && !defined (__CYGWIN__) && !defined (__MINGW32__)
 #include <win32config.h>
+#elif defined(VBOX)
+#include "vboxconfig.h"
 #else
 #include "config.h"
Index: trunk/src/libs/libxslt-1.1.22/libxslt/trio.h
===================================================================
--- trunk/src/libs/libxslt-1.1.22/libxslt/trio.h	(revision 7296)
+++ trunk/src/libs/libxslt-1.1.22/libxslt/trio.h	(revision 7299)
@@ -30,5 +30,9 @@
  */
 #if defined(HAVE_CONFIG_H)
-# include <config.h>
+# if defined(VBOX)
+#  include "vboxconfig.h"
+# else
+#  include <config.h>
+# endif
 #endif
 
Index: trunk/src/libs/libxslt-1.1.22/vboxconfig.h
===================================================================
--- trunk/src/libs/libxslt-1.1.22/vboxconfig.h	(revision 7299)
+++ trunk/src/libs/libxslt-1.1.22/vboxconfig.h	(revision 7299)
@@ -0,0 +1,165 @@
+/* config.h.in.  Generated from configure.in by autoheader.  */
+
+#if defined(RT_OS_LINUX)
+
+/* #undef HAVE_ISINF */
+/* #undef HAVE_ISNAN */
+#define HAVE_POW 1
+#define HAVE_FLOOR 1
+#define HAVE_FABS 1
+#undef WITH_DEBUGGER
+
+/* Define to 1 if you have the <ansidecl.h> header file. */
+/* #undef HAVE_ANSIDECL_H */
+
+/* Define to 1 if you have the `asctime' function. */
+#define HAVE_ASCTIME 1
+
+/* Define to 1 if you have the <dlfcn.h> header file. */
+#define HAVE_DLFCN_H 1
+
+/* Define to 1 if you have the <float.h> header file. */
+#define HAVE_FLOAT_H 1
+
+/* Define to 1 if you have the `fprintf' function. */
+#define HAVE_FPRINTF 1
+
+/* Define to 1 if you have the <fp_class.h> header file. */
+/* #undef HAVE_FP_CLASS_H */
+
+/* Define to 1 if you have the `ftime' function. */
+#define HAVE_FTIME 1
+
+/* Define if gcrypt library is available. */
+#define HAVE_GCRYPT 1
+
+/* Define to 1 if you have the `gettimeofday' function. */
+#define HAVE_GETTIMEOFDAY 1
+
+/* Define to 1 if you have the `gmtime_r' function. */
+#define HAVE_GMTIME_R 1
+
+/* Define to 1 if you have the <ieeefp.h> header file. */
+/* #undef HAVE_IEEEFP_H */
+
+/* Define to 1 if you have the <inttypes.h> header file. */
+#define HAVE_INTTYPES_H 1
+
+/* Define to 1 if you have the `localtime' function. */
+#define HAVE_LOCALTIME 1
+
+/* Define to 1 if you have the `localtime_r' function. */
+#define HAVE_LOCALTIME_R 1
+
+/* Define to 1 if you have the <math.h> header file. */
+#define HAVE_MATH_H 1
+
+/* Define to 1 if you have the <memory.h> header file. */
+#define HAVE_MEMORY_H 1
+
+/* Define to 1 if you have the `mktime' function. */
+#define HAVE_MKTIME 1
+
+/* Define to 1 if you have the <nan.h> header file. */
+/* #undef HAVE_NAN_H */
+
+/* Define to 1 if you have the `printf' function. */
+#define HAVE_PRINTF 1
+
+/* Define to 1 if you have the `snprintf' function. */
+#define HAVE_SNPRINTF 1
+
+/* Define to 1 if you have the `sprintf' function. */
+#define HAVE_SPRINTF 1
+
+/* Define to 1 if you have the `sscanf' function. */
+#define HAVE_SSCANF 1
+
+/* Define to 1 if you have the `stat' function. */
+#define HAVE_STAT 1
+
+/* Define to 1 if you have the <stdarg.h> header file. */
+#define HAVE_STDARG_H 1
+
+/* Define to 1 if you have the <stdint.h> header file. */
+#define HAVE_STDINT_H 1
+
+/* Define to 1 if you have the <stdlib.h> header file. */
+#define HAVE_STDLIB_H 1
+
+/* Define to 1 if you have the <strings.h> header file. */
+#define HAVE_STRINGS_H 1
+
+/* Define to 1 if you have the <string.h> header file. */
+#define HAVE_STRING_H 1
+
+/* Define to 1 if you have the <sys/select.h> header file. */
+#define HAVE_SYS_SELECT_H 1
+
+/* Define to 1 if you have the <sys/stat.h> header file. */
+#define HAVE_SYS_STAT_H 1
+
+/* Define to 1 if you have the <sys/timeb.h> header file. */
+#define HAVE_SYS_TIMEB_H 1
+
+/* Define to 1 if you have the <sys/time.h> header file. */
+#define HAVE_SYS_TIME_H 1
+
+/* Define to 1 if you have the <sys/types.h> header file. */
+#define HAVE_SYS_TYPES_H 1
+
+/* Define to 1 if you have the `time' function. */
+#define HAVE_TIME 1
+
+/* Define to 1 if you have the <time.h> header file. */
+#define HAVE_TIME_H 1
+
+/* Define to 1 if you have the <unistd.h> header file. */
+#define HAVE_UNISTD_H 1
+
+/* Define to 1 if you have the `vfprintf' function. */
+#define HAVE_VFPRINTF 1
+
+/* Define to 1 if you have the `vsnprintf' function. */
+#define HAVE_VSNPRINTF 1
+
+/* Define to 1 if you have the `vsprintf' function. */
+#define HAVE_VSPRINTF 1
+
+/* Define to 1 if you have the `_stat' function. */
+/* #undef HAVE__STAT */
+
+/* Name of package */
+#define PACKAGE "libxslt"
+
+/* Define to the address where bug reports for this package should be sent. */
+#define PACKAGE_BUGREPORT ""
+
+/* Define to the full name of this package. */
+#define PACKAGE_NAME ""
+
+/* Define to the full name and version of this package. */
+#define PACKAGE_STRING ""
+
+/* Define to the one symbol short name of this package. */
+#define PACKAGE_TARNAME ""
+
+/* Define to the version of this package. */
+#define PACKAGE_VERSION ""
+
+/* Define to 1 if you have the ANSI C header files. */
+#define STDC_HEADERS 1
+
+/* Version number of package */
+#define VERSION "1.1.22"
+
+/* Using the Win32 Socket implementation */
+/* #undef _WINSOCKAPI_ */
+
+/* Win32 Std C name mangling work-around */
+/* #undef snprintf */
+
+/* Win32 Std C name mangling work-around */
+/* #undef vsnprintf */
+
+#endif